package latex;
#|#######################################################
sub Index_T_Latex {
# index des fonctions
    open(LATEX,">$main::DIRE/texindex.tex");
    &Ouvre_SLatex ;
    &Ouvre_LLatex ;
    if (@main::programmes) {
    @liste=sort @main::programmes ;
    print LATEX "\\chapter{Programme}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = $nom ;
	$NOM =~ tr/A-Z/a-z/ ;
	$Nom = $nom ;
	$Nom =~ s/_/\\_/g ;
	$File = $file ;
	$File =~ s/_/\\_/g ;
	print LATEX "%\\begin{$Nom}\n" ;
	print LATEX "\\item {\\bf $Nom}\\label{$NOM} est d\\'eclar\\'e dans {\\bf $File}, ($main::L_Declar{$nom}).\n" ;
	&Gere_Latex ;
	print LATEX "%\\end{$Nom}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    if (@main::functions) {
    print LATEX "\\chapter{Liste alphab\\'etique des fonctions.}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    @liste=sort @main::functions ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = $nom ;
	$NOM =~ tr/A-Z/a-z/ ;
	$Nom = $nom ;
	$Nom =~ s/_/\\_/g ;
	$File = $file ;
	$File =~ s/_/\\_/g ;
	print LATEX "%\\begin{$Nom}\n" ;
	print LATEX "\\item {\\bf $Nom}\\label{$NOM} est d\\'eclar\\'ee dans {\\bf $File}, ($main::L_Declar{$nom}).\n" ;
	&Gere_Latex ;
	print LATEX "%\\end{$Nom}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    if (@main::routines) {
    print LATEX "\\chapter{Liste alphab\\'etique des routines.}\n" ;
    print LATEX "On met le num\\'ero de ligne d'appel ou de d\\'efinition entre parenth\\`eses.\n" ;
    print LATEX "\\hfill\\\\\\noindent\n" ;
    print LATEX "\\begin{enumerate}\n" ;
    @liste=sort @main::routines ;
    while (@liste) {
	($Routine,$file,$href)=split(/:/,shift @liste);
	$nom = $Routine ;
	$NOM = $nom ;
	$NOM =~ tr/A-Z/a-z/ ;
	$Nom = $nom ;
	$Nom =~ s/_/\\_/g ;
	$File = $file ;
	$File =~ s/_/\\_/g ;
	print LATEX "%\\begin{$Nom}\n" ;
	print LATEX "\\item {\\bf $Nom}\\label{$NOM} est d\\'eclar\\'ee dans {\\bf $File}, ($main::L_Declar{$nom}).\n" ;
	&Gere_Latex ;
	print LATEX "%\\end{$Nom}\n" ;
    }
    print LATEX "\\end{enumerate}\n" ;
    }
    close (LATEX) ;
}
#|#######################################################
sub Ouvre_SLatex {
    open(SLATEX,">$main::DIRE/Sindex.tex");
    $MonCode = $main::RepCodeSource ;
    $MonCode =~ s/_/\\_/g ;
print SLATEX <<'INFORMATION';
\documentclass[a4paper,10pt,twoside]{report}
\usepackage{fancyhdr}
\usepackage{makeidx}
\usepackage{hyperref}
\pagestyle{fancy}
\usepackage{french}
\textheight 23.0cm
\textwidth 16.0cm
\topmargin -0.55cm
\headsep 0.7cm
\marginparwidth 0.cm
\marginparsep 0.cm
\oddsidemargin 0.4cm
\evensidemargin -0.925cm 
\pagestyle{fancy}
\addtolength{\headwidth}{0cm}
\lfoot{\today}
INFORMATION
print SLATEX "\\rfoot{$main::USER}\n" ;
print SLATEX "\\lhead{Pr\\'esentation du code $MonCode.}\n" ;
print SLATEX <<'INFORMATION';
\begin{document}
INFORMATION
print SLATEX "\\author{$main::USER}\n" ;
print SLATEX "\\title{Pr\\'sentation du code $MonCode.}\n" ;
print SLATEX <<'INFORMATION';
\maketitle
\setcounter{page}{2}
\tableofcontents
\input texindex.tex
\end{document}
INFORMATION
    close (SLATEX) ;
}

#|#######################################################
sub Ouvre_LLatex {
    open(LLATEX,">$main::DIRE/Lindex.tex");
    $MonCode = $main::RepCodeSource ;
    $MonCode =~ s/_/\\_/g ;
print LLATEX <<'INFORMATION';
\documentclass[a4paper,12pt]{report}
\usepackage{fancyhdr}
\usepackage{makeidx}
\usepackage{hyperref}
\pagestyle{fancy}
\lfoot{\today}
INFORMATION
print LLATEX "\\rfoot{$main::USER}\n" ;
print LLATEX "\\lhead{Pr\\'esentation du code $MonCode.}\n" ;
print LLATEX <<'INFORMATION';
\begin{document}
INFORMATION
print LLATEX "\\author{$main::USER}\n" ;
print LLATEX "\\title{Pr\\'esentation du code $MonCode.}\n" ;
print LLATEX <<'INFORMATION';
\maketitle
\setcounter{page}{2}
\tableofcontents
\input texindex.tex
\end{document}
INFORMATION
    close (LLATEX) ;
} ;
#|#######################################################
sub Gere_Latex {
    print LATEX "\\begin{itemize}\n" ;
    &Gere_Latex_Appelants ;
    &Gere_Latex_Appellees ;
    &Gere_Latex_Include ;
    print LATEX "\\end{itemize}\n" ;
} ;
#|#######################################################
sub Gere_Latex_Appelants {
    local($ligne)="";
    unless ($main::Appelants{$nom}) {
	$ligne .= "\\item {\\bf $Nom} n'est appel\\'e par personne.\n";
    }
    if ($main::Appelants{$nom}) {
	@liste_appels_complet = sort keys %{$main::Appelants{$nom}} ;
	unless (@liste_appels_complet) {
	    $ligne .= "\\item {\\bf $Nom} n'est appel\\'e par personne.\n";
	}
	if (@liste_appels_complet) {
	    $ligne .= "\\item {\\bf $Nom} est appel\\'e par:\n";
	    $ligne .= "\\begin{itemize}\n" ;
	    foreach $Routine (@liste_appels_complet) {
		$fichier=$main::File_Of_Rout{$Routine} ;
		$RoutEncour = main::GetAlias($Routine);
		$ROutine = $Routine ;
		$ROutine =~ s/_/\\_/g ;
		$ligne .= "\\item $ROutine [r\\'ef \\ref{$RoutEncour}, p. \\pageref{$RoutEncour}] ligne(s)";
		$numloc=1 ;
		foreach $num (sort main::numerique split(/ /, ${$main::Appelants{$nom}}{$Routine})) {
		    if ($numloc) {
			$numloc=0 ;
		    } else {
			$ligne .= ", ";
		    }
		    $ligne .= " ($num)";
		}
	        $ligne .= ".\n";
	    }
	    $ligne .= "\\end{itemize}\n";
	}
    }
    print LATEX "$ligne" ;
} ;

#|#######################################################
sub Gere_Latex_Appellees {
    local($ligne)="";
    unless ($main::Appellees{$nom}) {
	$ligne .= "\\item {\\bf $Nom} n'appelle personne.\n";
    }
    if ($main::Appellees{$nom}) {
	@liste_appels_complet = sort keys %{$main::Appellees{$nom}} ;
	unless (@liste_appels_complet) {
	    $ligne .= "\\item {\\bf $Nom} n'appelle personne.\n";
	}
	if (@liste_appels_complet) {
	    $ligne .= "\\item {\\bf $Nom} appelle:\n";
	    $ligne .= "\\begin{itemize}\n" ;
	    $fichier=$main::File_Of_Rout{$nom} ;
	    foreach $Called_local (@liste_appels_complet) {
		$Reference = "";
		$Called_Minus = main::GetAlias($Called_local);
		if ($main::File_Of_Rout{$Called_local}) {
		    $Reference = $Called_local ;
		} elsif ($main::R_Declar{$Called_Minus}) {
		    $Reference = $main::R_Declar{$Called_Minus} ;
		}
		$CAlled_local = $Called_local ;
		$CAlled_local =~ s/_/\\_/g ;
		$Called_Minus = main::GetAlias($CAlled_local);
		$ligne .= "\\item ";
		if ($Reference) {
		    $ligne .= "$CAlled_local [r\\'ef \\ref{$Called_Minus}, p. \\pageref{$Called_Minus}] ligne(s)";
		} else {
		    $ligne .= "{\\it $CAlled_local} ligne(s)";
		}
		$numloc=1 ;
		foreach $num (sort main::numerique split(/ /, ${$main::Appellees{$nom}}{$Called_local})) {
	            if ($numloc) {
			$numloc=0 ;
		    } else {
			$ligne .= ", ";
		    }
		    $ligne .= " ($num)";
		}
	        $ligne .= ".\n";
           }
    }
	   $ligne .= "\\end{itemize}\n";
    }
print LATEX "$ligne" ;
} 

#|#######################################################
sub Gere_Latex_Include {
	if ($main::fonctions_includes{$nom}) {
	    @liste_appels_complet = sort split(/ /, $main::fonctions_includes{$nom});
	    print LATEX "\\item {\\bf $Nom} utilise:\n";
	    if (@liste_appels_complet) {
	    print LATEX "\\begin{itemize}\n" ;
	    while (@liste_appels_complet) {
	        @liste_appels=split(/:/, shift @liste_appels_complet);
		shift @liste_appels;
		$fichier=shift @liste_appels;
		$num=shift @liste_appels;
		$Fichier = $fichier ;
		$Fichier =~ s/_/\\_/g ;
print LATEX "\\item ";
print LATEX "$Fichier";
print LATEX " ($num)\n";
		$niveau = 0 ;
		$Fichier0 = $fichier ;
		if ($main::fonctions_includes{$fichier}) {
		if ( $niveau == 0 ){
print LATEX " qui utilise:\n";
		} elsif ( $niveau == 2 ){
print LATEX ";\n $Fichier0 utilise aussi:\n";
		} else {
print LATEX " qui utilise:\n";
		}
		    $niveau = 1 ;
		    @liste_appels_completR = sort split(/ /, $main::fonctions_includes{$fichier});
		    while (@liste_appels_completR) {
		        @liste_appelsR=split(/:/, shift @liste_appels_completR);
		        shift @liste_appelsR ;
		        $fichier=shift @liste_appelsR ;
		        $num=shift @liste_appelsR ;
		        $Fichier = $fichier ;
		        $Fichier =~ s/_/\\_/g ;
		        print LATEX "$Fichier";
		        print LATEX " ($num)\n";
		        if ($main::fonctions_includes{$fichier}) {
		            $niveau = 2 ;
print LATEX " qui utilise (rcursivit de niveau $niveau, maximum autoris):\n";
		            @liste_appels_completRR = sort split(/ /, $main::fonctions_includes{$fichier});
		            while (@liste_appels_completRR) {
		                @liste_appelsRR=split(/:/, shift @liste_appels_completRR);
		                shift @liste_appelsRR ;
		                $fichier=shift @liste_appelsRR ;
		                $num=shift @liste_appelsRR ;
		                $Fichier = $fichier ;
		                $Fichier =~ s/_/\\_/g ;
		                print LATEX "$Fichier";
		                print LATEX " ($num)\n";
		                if ($main::fonctions_includes{$fichier}) {
print LATEX " qui utilise encore d'autres fichiers...\n";
		                }
		            }
		        }
		    }
		}
	    }
	    print LATEX "\\end{itemize}\n" ;
	    }
	}
	if ($main::fonctions_includes{$main::File_Of_Rout{$nom}}) {
	    @liste_appels_complet = sort split(/ /, $main::fonctions_includes{$main::File_Of_Rout{$nom}});
	    print LATEX "\\item {\\bf $Nom} utilise en global:\n";
	    if (@liste_appels_complet) {
	    print LATEX "\\begin{itemize}\n" ;
	    while (@liste_appels_complet) {
	        @liste_appels=split(/:/, shift @liste_appels_complet);
		shift @liste_appels;
		$fichier=shift @liste_appels;
		$num=shift @liste_appels;
		$Fichier = $fichier ;
		$Fichier =~ s/_/\\_/g ;
print LATEX "\\item ";
print LATEX "$Fichier";
print LATEX " ($num)\n";
		$niveau = 0 ;
	    }
	    print LATEX "\\end{itemize}\n" ;
	    }
	}
} ;
1;


